From d3aa611a89c58de4a5a8139ccd7cb7890c0dfc7f Mon Sep 17 00:00:00 2001
From: Amul Sul <amul.sul@enterprisedb.com>
Date: Tue, 21 Sep 2021 06:05:36 -0400
Subject: [PATCH v35 06/10] Allow RequestCheckpoint() call from checkpointer
 process

---
 src/backend/postmaster/checkpointer.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/src/backend/postmaster/checkpointer.c b/src/backend/postmaster/checkpointer.c
index be7366379d0..9af7dec9212 100644
--- a/src/backend/postmaster/checkpointer.c
+++ b/src/backend/postmaster/checkpointer.c
@@ -924,9 +924,9 @@ RequestCheckpoint(int flags)
 				old_started;
 
 	/*
-	 * If in a standalone backend, just do it ourselves.
+	 * If in a standalone backend or checkpointer, just do it ourselves.
 	 */
-	if (!IsPostmasterEnvironment)
+	if (!IsPostmasterEnvironment || AmCheckpointerProcess())
 	{
 		/*
 		 * There's no point in doing slow checkpoints in a standalone backend,
-- 
2.18.0

